<?php
if (!defined('BASEPATH'))
   exit('No direct script access allowed');

/**
 *      user_api     
 * 
 * @author Evgenii Cherenov
 * @project SmartPPC6
 * @version 1.0.0
 */
class User_api extends CI_Model {
  /**
   *  
   *
   * @return   
   */  
   public function __construct() {
      parent::__construct();
   }
   /**
   *    
   *
   * @return array   
   */   
	public function get_color_schemes($id_publisher=null) {
	  $fields = array('id_color_scheme',
	                  'color_schemes.name as color_schemes_name',
	                  'border_color',
	                  'background_color',
	                  'title_color',
	                  'title_id_font',
	                  'title_font.name as title_font_name',
	                  'title_font_size',
	                  'title_font_style',
	                  'title_font_weight',
	                  'text_color',
                     'text_id_font',
                     'text_font.name as text_font_name',
                     'text_font_size',
                     'text_font_style',
                     'text_font_weight',
	                  'url_color',
                     'url_id_font',
                     'url_font.name as url_font_name',
                     'url_font_size',
                     'url_font_style',
                     'url_font_weight',
	                 'IF(id_entity_publisher,false,true) as is_system'
	  );
      if (isset($id_publisher)){
	     $this->db->select($fields)
              ->from('color_schemes')
              ->join('fonts as title_font','title_font.id_font = color_schemes.title_id_font','left')
              ->join('fonts as text_font','text_font.id_font = color_schemes.text_id_font','left')
              ->join('fonts as url_font','url_font.id_font = color_schemes.url_id_font','left')
              ->where('id_entity_publisher', 0)
			  ->or_where('id_entity_publisher', $id_publisher);
      }else{
	     $this->db->select($fields)
              ->from('color_schemes')
              ->join('fonts as title_font','title_font.id_font = color_schemes.title_id_font','left')
              ->join('fonts as text_font','text_font.id_font = color_schemes.text_id_font','left')
              ->join('fonts as url_font','url_font.id_font = color_schemes.url_id_font','left')
              ->where('id_entity_publisher', 0); 
	  }
			  
     $query = $this->db->get();
     if ($query->num_rows() > 0) {
        return $query->pdo_results;
     } else {
        return null;
     }
	} 
   
   /**
   *    
   *
   * @return array    
   */   
	public function get_sites_channels($id_publisher=null,$id_site=null) {
	   $fields = array('sites.id_site', 
	                 'id_entity_publisher',
	                 'sites.name as site_name', 
	                 'sites.description', 
	                 'c.id_channel',
	                 'c.name as channel_name', 					 
	                 'c.description', 
	                 'd.id_dimension', 
	                 'd.width', 
	                 'd.height'
	   );
      if ((isset($id_publisher)) and ($id_publisher!=null)){
	         $this->db->select($fields)
                     ->from('sites')
                     ->join('site_channels as sc','sc.id_site = sites.id_site','left')
                     ->join('channels as c','c.id_channel = sc.id_channel','left')
                     ->join('dimensions as d','d.id_dimension = c.id_dimension','left')
                  ->where('sites.id_entity_publisher', $id_publisher);
         if (isset($id_site) and ($id_site!=null)){         
            $this->db->where('sites.id_site', $id_site);
         }
         $this->db->where('sc.id_channel IS NOT NULL')
                  ->where('sites.status','active')
                  ->where('sc.status','active')
                  ->where('c.status','active')
                     ->order_by('sites.id_site');
       	$query = $this->db->get();
         if ($query->num_rows() > 0) {
              return $query->pdo_results;
         } 
	   }
	   return null;
	}	
   /**
   *    
   *
   * @return id   
   */      
   function searchUser ($apiKey){
      $this->db->select('id_entity')
               ->from('settings')
               ->where('name','apiKey')
               ->where('value',$apiKey);
      $query = $this->db->get();
      if ($query->num_rows() > 0) {   
         $row = $query->row();
         return $row->id_entity;
      } else {
        return null;
      }
   }
}